
CREATE TABLE Kunden (
    name CHAR(5), waggon_id INT);
CREATE TABLE Waggons (
    waggon_id INT PRIMARY KEY,
    Klasse CHAR(5));
INSERT INTO Kunden VALUES ('Klaus',15);
INSERT INTO Kunden VALUES ('Rudi',23);
INSERT INTO Waggons VALUES (15,'erste');


 SELECT name FROM Kunden 
    WHERE waggon_id =               /* Haupt */
    (SELECT waggon_id FROM Waggons 
      WHERE klasse = 'erste')  /* Unter */;

SELECT name FROM Kunden WHERE waggon_id =
  (SELECT MAX(waggon_id) FROM Kunden);


SELECT * FROM Kunden 
  WHERE waggon_id =
    (SELECT waggon_id FROM Waggons 
      WHERE Klasse = 'zweite');

SELECT * FROM Waggons WHERE waggon_id <
  ANY
  (SELECT waggon_id FROM Kunden);

SELECT * FROM Waggons WHERE waggon_id <
  ALL
  (SELECT waggon_id FROM Kunden);


SELECT * FROM Kunden WHERE 
  EXISTS (SELECT * FROM Waggons);


  SELECT * FROM Waggons W1
  WHERE NOT EXISTS (
    SELECT * FROM Kunden K2
    WHERE NOT EXISTS (
      SELECT * FROM Waggons W3
      WHERE W3.waggon_id = K2.waggon_id
      AND W3.waggon_id = W1.waggon_id));

SELECT ROW ('Klaus',15) =
   (SELECT name,waggon_id FROM Kunden WHERE waggon_id <> 23);


SELECT * FROM 
  (SELECT * FROM Kunden 
    WHERE name like 'K%') AS x;

UPDATE Waggons 
  SET waggon_id = 
   (SELECT AVG(waggon_id) FROM Kunden);

/* Die nchsten beiden Statements funktionieren nur mit neuen MySQL-Versionen */

SELECT * FROM Kunden
  WHERE name > (
    SELECT klasse from Waggons
    WHERE waggon_id = 15
    UNION ALL
    SELECT klasse FROM Waggons
    WHERE waggon_id = 4
    ORDER BY klasse);


SELECT (SELECT 1),Waggons.waggon_id +
         (SELECT waggon_id FROM Waggons) AS spalte2
  FROM Kunden, Waggons
  WHERE (SELECT name FROM Kunden WHERE waggon_id = 15) > Klasse
  ORDER BY spalte2;